/// <reference types="node" />
import * as beet from '@metaplex-foundation/beet';
import * as web3 from '@solana/web3.js';
export declare type AuctioneerAuthorityArgs = {
    bump: number;
};
export declare class AuctioneerAuthority implements AuctioneerAuthorityArgs {
    readonly bump: number;
    private constructor();
    static fromArgs(args: AuctioneerAuthorityArgs): AuctioneerAuthority;
    static fromAccountInfo(accountInfo: web3.AccountInfo<Buffer>, offset?: number): [AuctioneerAuthority, number];
    static fromAccountAddress(connection: web3.Connection, address: web3.PublicKey): Promise<AuctioneerAuthority>;
    static deserialize(buf: Buffer, offset?: number): [AuctioneerAuthority, number];
    serialize(): [Buffer, number];
    static get byteSize(): number;
    static getMinimumBalanceForRentExemption(connection: web3.Connection, commitment?: web3.Commitment): Promise<number>;
    static hasCorrectByteSize(buf: Buffer, offset?: number): boolean;
    pretty(): {
        bump: number;
    };
}
export declare const auctioneerAuthorityBeet: beet.BeetStruct<AuctioneerAuthority, AuctioneerAuthorityArgs & {
    accountDiscriminator: number[];
}>;
