"use strict";
var __createBinding = (this && this.__createBinding) || (Object.create ? (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    var desc = Object.getOwnPropertyDescriptor(m, k);
    if (!desc || ("get" in desc ? !m.__esModule : desc.writable || desc.configurable)) {
      desc = { enumerable: true, get: function() { return m[k]; } };
    }
    Object.defineProperty(o, k2, desc);
}) : (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    o[k2] = m[k];
}));
var __setModuleDefault = (this && this.__setModuleDefault) || (Object.create ? (function(o, v) {
    Object.defineProperty(o, "default", { enumerable: true, value: v });
}) : function(o, v) {
    o["default"] = v;
});
var __importStar = (this && this.__importStar) || function (mod) {
    if (mod && mod.__esModule) return mod;
    var result = {};
    if (mod != null) for (var k in mod) if (k !== "default" && Object.prototype.hasOwnProperty.call(mod, k)) __createBinding(result, mod, k);
    __setModuleDefault(result, mod);
    return result;
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.auctioneerAuthorityBeet = exports.AuctioneerAuthority = void 0;
const beet = __importStar(require("@metaplex-foundation/beet"));
const auctioneerAuthorityDiscriminator = [228, 74, 255, 245, 96, 83, 197, 12];
class AuctioneerAuthority {
    constructor(bump) {
        this.bump = bump;
    }
    static fromArgs(args) {
        return new AuctioneerAuthority(args.bump);
    }
    static fromAccountInfo(accountInfo, offset = 0) {
        return AuctioneerAuthority.deserialize(accountInfo.data, offset);
    }
    static async fromAccountAddress(connection, address) {
        const accountInfo = await connection.getAccountInfo(address);
        if (accountInfo == null) {
            throw new Error(`Unable to find AuctioneerAuthority account at ${address}`);
        }
        return AuctioneerAuthority.fromAccountInfo(accountInfo, 0)[0];
    }
    static deserialize(buf, offset = 0) {
        return exports.auctioneerAuthorityBeet.deserialize(buf, offset);
    }
    serialize() {
        return exports.auctioneerAuthorityBeet.serialize({
            accountDiscriminator: auctioneerAuthorityDiscriminator,
            ...this,
        });
    }
    static get byteSize() {
        return exports.auctioneerAuthorityBeet.byteSize;
    }
    static async getMinimumBalanceForRentExemption(connection, commitment) {
        return connection.getMinimumBalanceForRentExemption(AuctioneerAuthority.byteSize, commitment);
    }
    static hasCorrectByteSize(buf, offset = 0) {
        return buf.byteLength - offset === AuctioneerAuthority.byteSize;
    }
    pretty() {
        return {
            bump: this.bump,
        };
    }
}
exports.AuctioneerAuthority = AuctioneerAuthority;
exports.auctioneerAuthorityBeet = new beet.BeetStruct([
    ['accountDiscriminator', beet.uniformFixedSizeArray(beet.u8, 8)],
    ['bump', beet.u8],
], AuctioneerAuthority.fromArgs, 'AuctioneerAuthority');
//# sourceMappingURL=AuctioneerAuthority.js.map