"use strict";
var __createBinding = (this && this.__createBinding) || (Object.create ? (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    var desc = Object.getOwnPropertyDescriptor(m, k);
    if (!desc || ("get" in desc ? !m.__esModule : desc.writable || desc.configurable)) {
      desc = { enumerable: true, get: function() { return m[k]; } };
    }
    Object.defineProperty(o, k2, desc);
}) : (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    o[k2] = m[k];
}));
var __setModuleDefault = (this && this.__setModuleDefault) || (Object.create ? (function(o, v) {
    Object.defineProperty(o, "default", { enumerable: true, value: v });
}) : function(o, v) {
    o["default"] = v;
});
var __importStar = (this && this.__importStar) || function (mod) {
    if (mod && mod.__esModule) return mod;
    var result = {};
    if (mod != null) for (var k in mod) if (k !== "default" && Object.prototype.hasOwnProperty.call(mod, k)) __createBinding(result, mod, k);
    __setModuleDefault(result, mod);
    return result;
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.listingConfigBeet = exports.ListingConfig = void 0;
const beet = __importStar(require("@metaplex-foundation/beet"));
const ListingConfigVersion_1 = require("../types/ListingConfigVersion");
const Bid_1 = require("../types/Bid");
const listingConfigDiscriminator = [183, 196, 26, 41, 131, 46, 184, 115];
class ListingConfig {
    constructor(version, startTime, endTime, highestBid, bump, reservePrice, minBidIncrement, timeExtPeriod, timeExtDelta, allowHighBidCancel) {
        this.version = version;
        this.startTime = startTime;
        this.endTime = endTime;
        this.highestBid = highestBid;
        this.bump = bump;
        this.reservePrice = reservePrice;
        this.minBidIncrement = minBidIncrement;
        this.timeExtPeriod = timeExtPeriod;
        this.timeExtDelta = timeExtDelta;
        this.allowHighBidCancel = allowHighBidCancel;
    }
    static fromArgs(args) {
        return new ListingConfig(args.version, args.startTime, args.endTime, args.highestBid, args.bump, args.reservePrice, args.minBidIncrement, args.timeExtPeriod, args.timeExtDelta, args.allowHighBidCancel);
    }
    static fromAccountInfo(accountInfo, offset = 0) {
        return ListingConfig.deserialize(accountInfo.data, offset);
    }
    static async fromAccountAddress(connection, address) {
        const accountInfo = await connection.getAccountInfo(address);
        if (accountInfo == null) {
            throw new Error(`Unable to find ListingConfig account at ${address}`);
        }
        return ListingConfig.fromAccountInfo(accountInfo, 0)[0];
    }
    static deserialize(buf, offset = 0) {
        return exports.listingConfigBeet.deserialize(buf, offset);
    }
    serialize() {
        return exports.listingConfigBeet.serialize({
            accountDiscriminator: listingConfigDiscriminator,
            ...this,
        });
    }
    static get byteSize() {
        return exports.listingConfigBeet.byteSize;
    }
    static async getMinimumBalanceForRentExemption(connection, commitment) {
        return connection.getMinimumBalanceForRentExemption(ListingConfig.byteSize, commitment);
    }
    static hasCorrectByteSize(buf, offset = 0) {
        return buf.byteLength - offset === ListingConfig.byteSize;
    }
    pretty() {
        return {
            version: 'ListingConfigVersion.' + ListingConfigVersion_1.ListingConfigVersion[this.version],
            startTime: this.startTime,
            endTime: this.endTime,
            highestBid: this.highestBid,
            bump: this.bump,
            reservePrice: (() => {
                const x = this.reservePrice;
                if (typeof x.toNumber === 'function') {
                    try {
                        return x.toNumber();
                    }
                    catch (_) {
                        return x;
                    }
                }
                return x;
            })(),
            minBidIncrement: (() => {
                const x = this.minBidIncrement;
                if (typeof x.toNumber === 'function') {
                    try {
                        return x.toNumber();
                    }
                    catch (_) {
                        return x;
                    }
                }
                return x;
            })(),
            timeExtPeriod: this.timeExtPeriod,
            timeExtDelta: this.timeExtDelta,
            allowHighBidCancel: this.allowHighBidCancel,
        };
    }
}
exports.ListingConfig = ListingConfig;
exports.listingConfigBeet = new beet.BeetStruct([
    ['accountDiscriminator', beet.uniformFixedSizeArray(beet.u8, 8)],
    ['version', ListingConfigVersion_1.listingConfigVersionBeet],
    ['startTime', beet.i64],
    ['endTime', beet.i64],
    ['highestBid', Bid_1.bidBeet],
    ['bump', beet.u8],
    ['reservePrice', beet.u64],
    ['minBidIncrement', beet.u64],
    ['timeExtPeriod', beet.u32],
    ['timeExtDelta', beet.u32],
    ['allowHighBidCancel', beet.bool],
], ListingConfig.fromArgs, 'ListingConfig');
//# sourceMappingURL=ListingConfig.js.map