declare type ErrorWithCode = Error & {
    code: number;
};
declare type MaybeErrorWithCode = ErrorWithCode | null | undefined;
export declare class BumpSeedNotInHashMapError extends Error {
    readonly code: number;
    readonly name: string;
    constructor();
}
export declare class AuctionNotStartedError extends Error {
    readonly code: number;
    readonly name: string;
    constructor();
}
export declare class AuctionEndedError extends Error {
    readonly code: number;
    readonly name: string;
    constructor();
}
export declare class AuctionActiveError extends Error {
    readonly code: number;
    readonly name: string;
    constructor();
}
export declare class BidTooLowError extends Error {
    readonly code: number;
    readonly name: string;
    constructor();
}
export declare class SignerNotAuthError extends Error {
    readonly code: number;
    readonly name: string;
    constructor();
}
export declare class NotHighestBidderError extends Error {
    readonly code: number;
    readonly name: string;
    constructor();
}
export declare class BelowReservePriceError extends Error {
    readonly code: number;
    readonly name: string;
    constructor();
}
export declare class BelowBidIncrementError extends Error {
    readonly code: number;
    readonly name: string;
    constructor();
}
export declare class CannotCancelHighestBidError extends Error {
    readonly code: number;
    readonly name: string;
    constructor();
}
export declare function errorFromCode(code: number): MaybeErrorWithCode;
export declare function errorFromName(name: string): MaybeErrorWithCode;
export {};
