import * as beet from '@metaplex-foundation/beet';
import * as web3 from '@solana/web3.js';
export declare type BuyInstructionArgs = {
    tradeStateBump: number;
    escrowPaymentBump: number;
    auctioneerAuthorityBump: number;
    buyerPrice: beet.bignum;
    tokenSize: beet.bignum;
};
export declare type BuyInstructionAccounts = {
    auctionHouseProgram: web3.PublicKey;
    listingConfig: web3.PublicKey;
    seller: web3.PublicKey;
    wallet: web3.PublicKey;
    paymentAccount: web3.PublicKey;
    transferAuthority: web3.PublicKey;
    treasuryMint: web3.PublicKey;
    tokenAccount: web3.PublicKey;
    metadata: web3.PublicKey;
    escrowPaymentAccount: web3.PublicKey;
    authority: web3.PublicKey;
    auctionHouse: web3.PublicKey;
    auctionHouseFeeAccount: web3.PublicKey;
    buyerTradeState: web3.PublicKey;
    auctioneerAuthority: web3.PublicKey;
    ahAuctioneerPda: web3.PublicKey;
};
export declare function createBuyInstruction(accounts: BuyInstructionAccounts, args: BuyInstructionArgs): web3.TransactionInstruction;
