import * as beet from '@metaplex-foundation/beet';
import * as web3 from '@solana/web3.js';
export declare type CancelInstructionArgs = {
    auctioneerAuthorityBump: number;
    buyerPrice: beet.bignum;
    tokenSize: beet.bignum;
};
export declare type CancelInstructionAccounts = {
    auctionHouseProgram: web3.PublicKey;
    listingConfig: web3.PublicKey;
    seller: web3.PublicKey;
    wallet: web3.PublicKey;
    tokenAccount: web3.PublicKey;
    tokenMint: web3.PublicKey;
    authority: web3.PublicKey;
    auctionHouse: web3.PublicKey;
    auctionHouseFeeAccount: web3.PublicKey;
    tradeState: web3.PublicKey;
    auctioneerAuthority: web3.PublicKey;
    ahAuctioneerPda: web3.PublicKey;
};
export declare function createCancelInstruction(accounts: CancelInstructionAccounts, args: CancelInstructionArgs): web3.TransactionInstruction;
