import * as beet from '@metaplex-foundation/beet';
import * as web3 from '@solana/web3.js';
export declare type SellInstructionArgs = {
    tradeStateBump: number;
    freeTradeStateBump: number;
    programAsSignerBump: number;
    auctioneerAuthorityBump: number;
    tokenSize: beet.bignum;
    startTime: beet.bignum;
    endTime: beet.bignum;
    reservePrice: beet.COption<beet.bignum>;
    minBidIncrement: beet.COption<beet.bignum>;
    timeExtPeriod: beet.COption<number>;
    timeExtDelta: beet.COption<number>;
    allowHighBidCancel: beet.COption<boolean>;
};
export declare type SellInstructionAccounts = {
    auctionHouseProgram: web3.PublicKey;
    listingConfig: web3.PublicKey;
    wallet: web3.PublicKey;
    tokenAccount: web3.PublicKey;
    metadata: web3.PublicKey;
    authority: web3.PublicKey;
    auctionHouse: web3.PublicKey;
    auctionHouseFeeAccount: web3.PublicKey;
    sellerTradeState: web3.PublicKey;
    freeSellerTradeState: web3.PublicKey;
    auctioneerAuthority: web3.PublicKey;
    ahAuctioneerPda: web3.PublicKey;
    programAsSigner: web3.PublicKey;
};
export declare function createSellInstruction(accounts: SellInstructionAccounts, args: SellInstructionArgs): web3.TransactionInstruction;
