"use strict";
var __createBinding = (this && this.__createBinding) || (Object.create ? (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    var desc = Object.getOwnPropertyDescriptor(m, k);
    if (!desc || ("get" in desc ? !m.__esModule : desc.writable || desc.configurable)) {
      desc = { enumerable: true, get: function() { return m[k]; } };
    }
    Object.defineProperty(o, k2, desc);
}) : (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    o[k2] = m[k];
}));
var __setModuleDefault = (this && this.__setModuleDefault) || (Object.create ? (function(o, v) {
    Object.defineProperty(o, "default", { enumerable: true, value: v });
}) : function(o, v) {
    o["default"] = v;
});
var __importStar = (this && this.__importStar) || function (mod) {
    if (mod && mod.__esModule) return mod;
    var result = {};
    if (mod != null) for (var k in mod) if (k !== "default" && Object.prototype.hasOwnProperty.call(mod, k)) __createBinding(result, mod, k);
    __setModuleDefault(result, mod);
    return result;
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.createSellInstruction = void 0;
const splToken = __importStar(require("@solana/spl-token"));
const beet = __importStar(require("@metaplex-foundation/beet"));
const web3 = __importStar(require("@solana/web3.js"));
const sellStruct = new beet.FixableBeetArgsStruct([
    ['instructionDiscriminator', beet.uniformFixedSizeArray(beet.u8, 8)],
    ['tradeStateBump', beet.u8],
    ['freeTradeStateBump', beet.u8],
    ['programAsSignerBump', beet.u8],
    ['auctioneerAuthorityBump', beet.u8],
    ['tokenSize', beet.u64],
    ['startTime', beet.i64],
    ['endTime', beet.i64],
    ['reservePrice', beet.coption(beet.u64)],
    ['minBidIncrement', beet.coption(beet.u64)],
    ['timeExtPeriod', beet.coption(beet.u32)],
    ['timeExtDelta', beet.coption(beet.u32)],
    ['allowHighBidCancel', beet.coption(beet.bool)],
], 'SellInstructionArgs');
const sellInstructionDiscriminator = [51, 230, 133, 164, 1, 127, 131, 173];
function createSellInstruction(accounts, args) {
    const { auctionHouseProgram, listingConfig, wallet, tokenAccount, metadata, authority, auctionHouse, auctionHouseFeeAccount, sellerTradeState, freeSellerTradeState, auctioneerAuthority, ahAuctioneerPda, programAsSigner, } = accounts;
    const [data] = sellStruct.serialize({
        instructionDiscriminator: sellInstructionDiscriminator,
        ...args,
    });
    const keys = [
        {
            pubkey: auctionHouseProgram,
            isWritable: false,
            isSigner: false,
        },
        {
            pubkey: listingConfig,
            isWritable: true,
            isSigner: false,
        },
        {
            pubkey: wallet,
            isWritable: true,
            isSigner: false,
        },
        {
            pubkey: tokenAccount,
            isWritable: true,
            isSigner: false,
        },
        {
            pubkey: metadata,
            isWritable: false,
            isSigner: false,
        },
        {
            pubkey: authority,
            isWritable: false,
            isSigner: false,
        },
        {
            pubkey: auctionHouse,
            isWritable: false,
            isSigner: false,
        },
        {
            pubkey: auctionHouseFeeAccount,
            isWritable: true,
            isSigner: false,
        },
        {
            pubkey: sellerTradeState,
            isWritable: true,
            isSigner: false,
        },
        {
            pubkey: freeSellerTradeState,
            isWritable: true,
            isSigner: false,
        },
        {
            pubkey: auctioneerAuthority,
            isWritable: false,
            isSigner: false,
        },
        {
            pubkey: ahAuctioneerPda,
            isWritable: false,
            isSigner: false,
        },
        {
            pubkey: programAsSigner,
            isWritable: false,
            isSigner: false,
        },
        {
            pubkey: splToken.TOKEN_PROGRAM_ID,
            isWritable: false,
            isSigner: false,
        },
        {
            pubkey: web3.SystemProgram.programId,
            isWritable: false,
            isSigner: false,
        },
        {
            pubkey: web3.SYSVAR_RENT_PUBKEY,
            isWritable: false,
            isSigner: false,
        },
    ];
    const ix = new web3.TransactionInstruction({
        programId: new web3.PublicKey('neer8g6yJq2mQM6KbnViEDAD4gr3gRZyMMf4F2p3MEh'),
        keys,
        data,
    });
    return ix;
}
exports.createSellInstruction = createSellInstruction;
//# sourceMappingURL=sell.js.map